'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcTooltip = require('rc-tooltip');

var _rcTooltip2 = _interopRequireDefault(_rcTooltip);

var _placements = require('./placements');

var _placements2 = _interopRequireDefault(_placements);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var placements = (0, _placements2.default)();

var Popover = function (_React$Component) {
  _inherits(Popover, _React$Component);

  function Popover() {
    _classCallCheck(this, Popover);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Popover).apply(this, arguments));
  }

  _createClass(Popover, [{
    key: 'render',
    value: function render() {
      var transitionName = {
        top: 'zoom-down',
        bottom: 'zoom-up',
        left: 'zoom-right',
        right: 'zoom-left',
        topLeft: 'zoom-down',
        bottomLeft: 'zoom-up',
        leftTop: 'zoom-right',
        rightTop: 'zoom-left',
        topRight: 'zoom-down',
        bottomRight: 'zoom-up',
        leftBottom: 'zoom-right',
        rightBottom: 'zoom-left'
      }[this.props.placement];

      return _react2.default.createElement(
        _rcTooltip2.default,
        _extends({ transitionName: transitionName,
          builtinPlacements: placements,
          ref: 'tooltip'
        }, this.props, {
          overlay: this.getOverlay() }),
        this.props.children
      );
    }
  }, {
    key: 'getPopupDomNode',
    value: function getPopupDomNode() {
      return this.refs.tooltip.getPopupDomNode();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if ('overlay' in this.props) {
        (0, _warning2.default)(false, '`overlay` prop of Popover is deperated, use `content` instead.');
      }
    }
  }, {
    key: 'getOverlay',
    value: function getOverlay() {
      // use content replace overlay
      // keep overlay for compatibility
      var _props = this.props;
      var title = _props.title;
      var prefixCls = _props.prefixCls;
      var overlay = _props.overlay;
      var content = _props.content;


      return _react2.default.createElement(
        'div',
        null,
        title && _react2.default.createElement(
          'div',
          { className: prefixCls + '-title' },
          title
        ),
        _react2.default.createElement(
          'div',
          { className: prefixCls + '-inner-content' },
          content || overlay
        )
      );
    }
  }]);

  return Popover;
}(_react2.default.Component);

Popover.defaultProps = {
  prefixCls: 'ant-popover',
  placement: 'top',
  trigger: 'hover',
  mouseEnterDelay: 0.1,
  mouseLeaveDelay: 0.1,
  overlayStyle: {}
};
exports.default = Popover;
module.exports = exports['default'];