'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rcProgress = require('rc-progress');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var prefixCls = 'ant-progress';

var statusColorMap = {
  normal: '#2db7f5',
  exception: '#ff5500',
  success: '#87d068'
};

var Circle = function (_React$Component) {
  _inherits(Circle, _React$Component);

  function Circle() {
    _classCallCheck(this, Circle);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Circle).apply(this, arguments));
  }

  _createClass(Circle, [{
    key: 'render',
    value: function render() {
      var props = _extends({}, this.props);

      if (parseInt(props.percent, 10) === 100) {
        props.status = 'success';
      }

      var style = {
        width: props.width,
        height: props.width,
        fontSize: props.width * 0.16 + 6
      };
      var progressInfo = void 0;

      var format = props.format || function (percent) {
        return percent + '%';
      };

      if (props.status === 'exception') {
        progressInfo = _react2.default.createElement(
          'span',
          { className: prefixCls + '-circle-text' },
          props.format ? format(props.percent) : _react2.default.createElement(_icon2.default, { type: 'exclamation' })
        );
      } else if (props.status === 'success') {
        progressInfo = _react2.default.createElement(
          'span',
          { className: prefixCls + '-circle-text' },
          props.format ? format(props.percent) : _react2.default.createElement(_icon2.default, { type: 'check' })
        );
      } else {
        progressInfo = _react2.default.createElement(
          'span',
          { className: prefixCls + '-circle-text' },
          format(props.percent)
        );
      }

      return _react2.default.createElement(
        'div',
        { className: prefixCls + '-circle-wrap status-' + props.status, style: props.style },
        _react2.default.createElement(
          'div',
          { className: prefixCls + '-circle-inner', style: style },
          _react2.default.createElement(_rcProgress.Circle, { percent: props.percent, strokeWidth: props.strokeWidth,
            strokeColor: statusColorMap[props.status], trailColor: props.trailColor }),
          progressInfo
        )
      );
    }
  }]);

  return Circle;
}(_react2.default.Component);

Circle.defaultProps = {
  width: 132,
  percent: 0,
  strokeWidth: 6,
  status: 'normal', // exception
  trailColor: '#f3f3f3'
};
Circle.propTypes = {
  status: _react2.default.PropTypes.oneOf(['normal', 'exception', 'success']),
  percent: _react2.default.PropTypes.number,
  strokeWidth: _react2.default.PropTypes.number,
  width: _react2.default.PropTypes.number,
  trailColor: _react2.default.PropTypes.string,
  format: _react2.default.PropTypes.func
};
exports.default = Circle;
module.exports = exports['default'];