'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var prefixCls = 'ant-progress';

var Line = function (_React$Component) {
  _inherits(Line, _React$Component);

  function Line() {
    _classCallCheck(this, Line);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Line).apply(this, arguments));
  }

  _createClass(Line, [{
    key: 'render',
    value: function render() {
      var props = _extends({}, this.props);

      if (parseInt(props.percent, 10) === 100) {
        props.status = 'success';
      }

      var progressInfo = void 0;
      var fullCls = '';

      var format = props.format || function (percent) {
        return percent + '%';
      };

      if (props.showInfo) {
        if (props.status === 'exception') {
          progressInfo = _react2.default.createElement(
            'span',
            { className: prefixCls + '-line-text' },
            props.format ? format(props.percent) : _react2.default.createElement(_icon2.default, { type: 'cross-circle' })
          );
        } else if (props.status === 'success') {
          progressInfo = _react2.default.createElement(
            'span',
            { className: prefixCls + '-line-text' },
            props.format ? format(props.percent) : _react2.default.createElement(_icon2.default, { type: 'check-circle' })
          );
        } else {
          progressInfo = _react2.default.createElement(
            'span',
            { className: prefixCls + '-line-text' },
            format(props.percent)
          );
        }
      } else {
        fullCls = ' ' + prefixCls + '-line-wrap-full';
      }
      var percentStyle = {
        width: props.percent + '%',
        height: props.strokeWidth
      };

      return _react2.default.createElement(
        'div',
        { className: prefixCls + '-line-wrap clearfix status-' + props.status + fullCls, style: props.style },
        _react2.default.createElement(
          'div',
          { className: prefixCls + '-line-outer' },
          _react2.default.createElement(
            'div',
            { className: prefixCls + '-line-inner' },
            _react2.default.createElement('div', { className: prefixCls + '-line-bg', style: percentStyle })
          )
        ),
        progressInfo
      );
    }
  }]);

  return Line;
}(_react2.default.Component);

Line.defaultProps = {
  percent: 0,
  strokeWidth: 10,
  status: 'normal', // exception active
  showInfo: true,
  trailColor: '#f3f3f3'
};
Line.propTypes = {
  status: _react2.default.PropTypes.oneOf(['normal', 'exception', 'active', 'success']),
  showInfo: _react2.default.PropTypes.bool,
  percent: _react2.default.PropTypes.number,
  strokeWidth: _react2.default.PropTypes.number,
  trailColor: _react2.default.PropTypes.string,
  format: _react2.default.PropTypes.func
};
exports.default = Line;
module.exports = exports['default'];